;TI-Keyboard
;By: Cullen Ashford Logan
;evilson1@austin.rr.com
;http://www.psikan.com
;This is a demo driver for gettign input from a PS2 keyboard into the calc.
;I hope someone will take it and make a text editor...I'm far too lazy!!!
;
;Version: .01b
;Version recompile pour TI-82 par Marc Plouhinec (www.thebestof.tk, m_plouhinec@yahoo.fr)
;attention! avec la rom 19.006, les signaux  envoyer vers le port link sont diffrents!


#include "sngbeta.inc"

.org START_ADDR
    .db "PS2 Keyboard Driver",0
    

;pour les anciennes TI-82
#define   C0anc_rom       $C0
#define   D4anc_rom       $D4
#define   E8anc_rom       $E8
#define   FCanc_rom       $FC
;pour les nouvelles TI-82 (merci  http://www.planeteti82.fr.st)
#define   C0nouv_rom      $C0
#define   D4nouv_rom      $C1
#define   E8nouv_rom      $C2
#define   FCnouv_rom      $C3


;Rajout de marc Plouhinec: routine qui adapte les signaux  envoyer vers le port link selon la version de la rom
 LD A,($29D0) ;pour rom |16.0:36| |17.0:37| |18.0:38| |19.0:6D| |19.006:18|
 CP $18
 JR Z,nouv_rom
;anc_rom:
 LD A,$D4
 LD (adr_renom_D4),A
 LD A,$E8
 LD (adr_renom_e8),A
 LD (adr_renom2_e8),A
 LD A,$FC
 LD (adr_renom_fc),A
 JR ProgStart
nouv_rom:
;ici on adapte les signaux  envoyer pour les nouveaux modles
 LD A,$C1
 LD (adr_renom_D4),A
 LD A,$C2
 LD (adr_renom_e8),A
 LD (adr_renom2_e8),A
 LD A,$C3
 LD (adr_renom_fc),A

ProgStart:
    di
;    call _flushallmenus ;if menus open close them
;    ROM_CALL(BUSY_OFF)   ; Turn off run indicator
    ROM_CALL(CLEARLCD)        ;gimme a clean screen to work with
;    call _homeup        ;don't really think I need this one
    xor a               ;a = 0
    ld (case),a         ;case = 0: lower case letter and characters
    ld a,C0anc_rom
    out (P_LINK),a
    ld hl,0             ;hl = 0
    ld (length),hl      ;length = 0
    nop
    nop
;initializing:
;   ld c,$ED
;   call sendbytetokbd
;   call getbytefromkbd ;ack!!!
;    ld c,$02
;    call sendbytetokbd  
;    call getbytefromkbd ;ack!!!
;    ld hl,$0000
;    ld hl,(_curRow)
;    ld hl,text
;    call _puts




here:    
    call getbytefromkbd     ;if we get past this then good!!!!
    ;now inhibit communication until we return to here
    ;ld a,$fc
    ;out (7),a
    ld a,e
    cp $76                  ;is the number $76???
    jp z,goodbye            ;if so escape has been pressed quit the program.
    cp $66
    jp z,backspace
    cp $12
    jp z,spacepressed
    cp $59
    jp z,spacepressed
    cp $F0                  ;is it $F0???
    jp z,releasecode   ;if so then we have released a kbd key so we do o outputting of characters to the screen
    ld bc,endofscancodes-scancodes   ;store length of table into register b
    ld hl,scancodes      ;ld hl with the memory address of the scancodes
    cpir                 ;do what the below code does but a bit faster and in less space
    jp nz,here      ;Scan code not found
    ld bc,calcchar-scancodes-1  ;bc length of scancodes - 1
    add hl,bc               ;hl=hl+bc hl= length of scancodes
    ld a,(case)     ;what case are we in?
    ld b,0          ;b=0
    ld c,a          ;c=case(0 or length of scancodes)
    add hl,bc       ;
    ld a,(hl)
    ld hl,(length)
    inc hl
    ld (length),hl
    ROM_CALL(M_CHARPUT)    ;put character to screen
    xor a
    ld (case),a
    jp here

spacepressed:
    ld a,calcchar_upper-calcchar
    ld (case),a
    jp here
releasecode:
    call getbytefromkbd
    ld a,e
    cp $12
    jp z,spacereleased
    cp $59
    jp nz,here
spacereleased:
    xor a
    ld (case),a
    jp here
goodbye:
    ei
    ret
backspace:
    ld hl,(length)
    ld a,h
    or l        ;if length is zero then do not backspace at all
    jp z,here
    ld hl,(CURSOR_ROW)  ;hl = current row
    ld a,h
    or l             ;if currow and curcol zero then
    jp z,here
    call cursorback
    ld a,' '
    ROM_CALL(M_CHARPUT)
    ld hl,(length)
    dec hl
    ld (length),hl
    jp here
cursorback:
    ld a,(CURSOR_COL)
    or a
    jp z,cursorback_row
    dec a
    ld (CURSOR_COL),a
    ret
cursorback_row:
    ld a,21
    ld (CURSOR_COL),a
    ld hl,CURSOR_ROW 
    dec (hl)
    ret

;/////////////////////////////////////////////////////////////////////////////////////////////////////////
;getbytefromkbd...optimized by Mike Heckenbach (sp?)
;/////////////////////////////////////////////////////////////////////////////////////////////////////////
getbytefromkbd:
    ld b,8
    ld a,C0anc_rom
    out (P_LINK),a
    ld d,%00000011   ;cache the bitmask in a reg
waitforstartbit:
    in a,(P_LINK)
    and d      ;sets the flags, no need for 'or a'
    jr nz,waitforstartbit ;I still remain unconvinced that jp is faster, but feel free to change it back to jp if you disagree.

    nop        ;not sure why, but you have it, so...
               ;also, may need more due to the above?
waitclockhigh:
    in a,(P_LINK)
    rrca       ;put low bit in the carry flag
    jr nc,waitclockhigh   ;the bit was clear
waitclocklow:
    in a,(P_LINK)
    rrca
    jr c,waitclocklow     ;the bit was set
    nop        ;* N
    in a,(P_LINK)
    rrca       ;bit 1 -> bit 0
    rrca       ;         bit 0 -> carry flag
    rr e
    djnz waitclockhigh
waitforparitybit:
    in a,(P_LINK)
    rrca
    jr nc,waitforparitybit
waitforparitydata:
    in a,(P_LINK)
    rrca
    jr c,waitforparitydata
    ret




;/////////////////////////////////////////////////////////////////////////////////////////////////////////
;getbytefromkbd: recieve byte from ps2 keyboard - old routine
;/////////////////////////////////////////////////////////////////////////////////////////////////////////
;inputs: none
;ouputs: c(contains 8-bit scan-code)
;destroyed: too lazy to tell...you figure it out.
;/////////////////////////////////////////////////////////////////////////////////////////////////////////
;getbytefromkbd:
;    ld b,8              ;bit counter
;    ld a,$C0            ;both need to be high so transmission isn't inhibited
;    out (7),a
;waitforstartbit:        ;this occurs when dataline (middle of calc port) goes low...poll the port rapidly
;    in a,(7)            ;check port for current state
;    and %00000011       ;filter all bits but the lower 2
;    
;    jp nz,waitforstartbit;if both still high then we must keep waiting
;    nop
;waitclockhigh:    
;    in a,(7)            ;wait for clock high
;    and 1               ;check bit 0(indexed from 0)            
;    jp z,waitclockhigh ;if it wasn't one then repeat waitclockhigh
;waitclocklow:           ;wait for clock low to get new latch value
;    in a,(7)            ;examine current state
;    and 1
;    jp nz,waitclocklow  ;if not 0 then clock is high...keep waiting
;    nop \ nop \ nop \ nop \ nop ;the number of ops is dependent on the calculator!!! and its speed
    ;nop \ nop \ nop \ nop \ nop
    ;nop \ nop \ nop \ nop \ nop
    ;nop \ nop \ nop \ nop \ nop \ nop \ nop \ nop
;    in a,(7)            ;examine port    
;    and 2               ;mask out all but bit 1
;    cp 2
;    call z,datahigh     ;if it is equal to 2 then data is high
;    call nz,datalow     ;if not equal to 2 then data is low
;    rr e                ;shift in the carryflag value and move all bits to the left
;    djnz waitclockhigh   ;if we get here we are done...maybe just pause for a few millisecond...i don't care about stop bit or parity
;waitforparitybit:       ;or we can take clock low and inhibit keyboard transfer!!!!!!
;    in a,(7)            ;wait for clock high
;    and 1               ;check bit 0(indexed from 0)              
;    jp z,waitforparitybit      ;clock hasn't gone high yet
;waitforparitydata:
;    in a,(7)            ;examine current state
;    and 1
;    jp nz,waitforparitydata   ;if 0 then clock is low...we have new latched value
;    ret
;datahigh:               ;we need to set carry flag!!! so we can rr c and the high value will be moved in!
;    scf              ;this should set the carry flag!!!
;    ret                 ;go back to getbit
;datalow:
;    or a              ;this should clear the carry flag!!!
;    ret
;////////////////////////////////////////////////////////////////////////////////////////////////





;//////////////////////////////////////////////////////////////////////////
;       Function sends value in c to the keyboard
;//////////////////////////////////////////////////////////////////////////
;inputs: c:byte to send...used in intialization and setup of kbd
;outputs: none
;destroyed:  too lazy to figure it out...you do it
;
;1.Pull clock low for at least 100 microseconds
;2.Pull data low
;3.Relese clock
;4.Wait for kbd to bring clock line low
;5.Send out first data bit
;6.Wait for kbd to bring clock high
;7.Wait for clock low again
;8.Repeat 5-7 for the next 7 bits and the parity bit
;9.Release the Data line (let it go high)
;10.Wait for kbd to bring data low
;11.Wait for kbd to bring clock low
;12.Wait for release of data and clock
;///////////////////////////////////////////////////////////////////////////
sendbytetokbd:
    ld a,D4anc_rom            ;gonna bring clock line low for 100 microseconds
adr_renom_D4 = $ -1
    out (P_LINK),a           ;done
inhibit:    
    ;call millisecondpause
    ld a,FCanc_rom            ;now bring data low
adr_renom_fc = $-1
    out (P_LINK),a
    ;call microsecondpause
    ;call microsecondpause
    ld a,E8anc_rom            ;release clock
adr_renom_e8 = $-1
    out (P_LINK),a
    nop
    nop                    
    ld b,8              ;we have 8 data bits to clock out
waitforclocklow:
    in a,(P_LINK)            ;examine current state
    and 1
    cp 0                ;check state of clock line
    jp nz,waitforclocklow  ;if not 0 then clock is high...keep waiting
    ld a,c              ;a = byte to clock out...we are going to trash it
    and 1               ;mask out bit one
    cp 1                ;compare our new value with 1
    ;call microsecondpause
    call z,send_one     ;if zero flag set then values are equal
    call nz,send_zero   ;otherwaise they are not....means we have a zero
    rrc c               ;rotate the value in c to the right so we can start over again
waitforclockhigh:
    in a,(P_LINK)            ;check for clock high
    and 1
    cp 1
    jp nz,waitforclockhigh
    djnz waitforclocklow

;done sending the byte data at this point..clock is in a high state
;also note that b should be zero...might be used to optimize code in the future...timing is critical   
waittosendparity:
    in a,(P_LINK)            ;wait for clock to go low
    and 1
    cp 1
    jp z,waittosendparity   ;repeat until clock line is low
    ;call microsecondpause
    call send_one          ;send our parity bit...maybe i can reuse code....i dunno
endparity:
    in a,(P_LINK)            ;check for clock high
    and 1               ;repeat till clock is high again
    cp 1
    jp nz,endparity
    ;call microsecondpause
    ;call microsecondpause
    ld a,C0anc_rom            ;both are floating now
    out (P_LINK),a  
waitforlows:            ;waiting till kbd brings both lines low
    in a,(P_LINK)
    and 3               ;check bit 0 and 1
    cp 0                ;we want it to be zero!!!
    jp nz,waitforlows   ;keep waiting
waitforhighs:
    in a,(P_LINK)
    and 3               ;check bit 0 and 1
    cp 3                ;we want it to be three!!!
    jp nz,waitforhighs  ;keep waiting
    ;ld a,$C0            ;put into recieve mode for confirmation...if it exists
    ;out (7),a
    ret                 ;done with entire byte send!!!!

send_one:
    ld a,C0anc_rom            ;clock line stays high
    out (P_LINK),a
    ret
send_zero:
    ld a,E8anc_rom            ;clock line stays high
adr_renom2_e8 = $-1
    out (P_LINK),a
    ret
;//////////////////////////////////////////////////////////////////////////////////////////////////////////

menu:
    .db "1.Establish Communication",0


text:
    .db "init done",0

scancodes:
    .db $1C,$32,$21,$23,$24,$2B,$34,$33,$43,$3B,$42,$4B,$3A,$31,$44,$4D
    .db $15,$2D,$1B,$2C,$3C,$2A,$1D,$22,$35,$1A,$45,$16,$1E,$26,$25
    .db $2E,$36,$3D,$3E,$46,$0E,$4E,$5D,$29,$54,$5B,$4C,$52,$41,$4A
endofscancodes:

calcchar:
    ;Lowercase
    .db $61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70
    .db $71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$30,$31,$32,$33,$34
    .db $35,$36,$37,$38,$39,$60,$2E,$5C,$20,$C1,$5D,$3B,$27,$2C,$2F
calcchar_upper:
    ;Uppercase

    .db $41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50
    .db $51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$29,$21,$40,$23,$1E
    .db $25,$5E,$26,$2A,$28,$7E,$3E,$7C,$20,$7B,$7D,$3A,$22,$3C,$3F
endofcalcchar:

set1:
    .db $1E,$30,$2E,$20,$12,$21,$22,$23,$17,$24,$25,$26,$32,$31,$18,$19
    .db $10,$13,$1F,$14,$16,$2F,$11,$2D,$15,$2C,$29,$FF
endset1:


length:
    .db 0
pointer:
    .db 0
mem:
    .db 0
case:
    .db 0

initialization:
    .db $ED,$00,$F2,$ED,$02,$F3,$60,$F0,$01,$F4
initend:

.end
